//<c>   Copyright 1997-1999 by Gerry J. Danen; all rights reserved.

//<t>   BusyOut a COM port

#include"gd_tools.h"


#define pgVERS_ "V1.10"
#define pgTITL_ "Take Modem OffHook"
#define pgCOPR_ "1997"


char    bombed = 0 ;


// **********************************************************
//      critical_handler() -- DOS critical error handler
// **********************************************************

void    far interrupt critical_handler(
            unsigned _bp, unsigned _di, unsigned _si, unsigned _ds,
            unsigned _es, unsigned _dx, unsigned _cx, unsigned _bx,
            unsigned _ax, unsigned _cs, unsigned _ip, unsigned _flags )
{
    bombed = 1 ;
    _ax = 0x0003 ;
}


void    exit_routine( void )
{
    if ( bombed )
        printf( " ... FAILED.\a\n" );
    else
        printf( " ... OK.\n" );
}


STRING  determineComPort( STRING par )
{
    if ( st_eq(par, "1") || st_eq(par, "Com1") || st_eq(par, "Com1:") )
        return( "COM1" );
    if ( st_eq(par, "2") || st_eq(par, "Com2") || st_eq(par, "Com2:") )
        return( "COM2" );
    if ( st_eq(par, "3") || st_eq(par, "Com3") || st_eq(par, "Com3:") )
        return( "COM3" );
    if ( st_eq(par, "4") || st_eq(par, "Com4") || st_eq(par, "Com4:") )
        return( "COM4" );
    printf( "Invalid argument: %s\n", par );
    return( "COM1" );
}


void    main( int argc, char *argv[] )
{
    FILE        *port ;
    char        sPortName[5] = "COM1" ;         // default is COM1:
    char        sBusy[] = "ATM0H1" ;            // modem command

//  tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    atexit( exit_routine );                     // set up to close orderly

    _dos_setvect( 0x24, critical_handler );     // critical error handler

    if ( argc > 1 )
        strcpy( sPortName, determineComPort( argv[1] ) );

    printf( "Taking modem on port %s offhook, with command \"%s\"",
            sPortName, sBusy );

    port = fopen( sPortName, "w" );
    fprintf( port, "%s\n", sBusy );
    fclose( port );

    exit( bombed );
}
